## scram 0.16.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

# In-source build prevention.
set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)

project(SCRAM VERSION 0.16.1 LANGUAGES CXX)

####################### Begin Options ###################

option(WITH_TCMALLOC "Use TCMalloc if available (#1 preference)" ON)
option(WITH_JEMALLOC "Use JEMalloc if available (#2 preference)" ON)

option(WITH_COVERAGE "Instrument for coverage analysis" OFF)
option(WITH_PROFILE "Instrument for performance profiling" OFF)

option(HAS_TANGO "The system provides the fall-back Tango icons" OFF)

option(BUILD_GUI "Build the GUI front-end" ON)
option(BUILD_TESTING "Build the tests" OFF)  # Influences CTest.

option(PACKAGE "Package for distribution" OFF)

####################### End Options ###################

####################### Begin compiler configurations ###################

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)  # Needed for Clang Tooling.

# Default to C++14.
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

function(CHECK_COMPILER_VERSION MIN_VERSION)
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS MIN_VERSION)
    message(FATAL_ERROR "${CMAKE_CXX_COMPILER_ID} Compiler version too old. Required minimum version: ${MIN_VERSION}")
  endif()
endfunction()

add_definitions(-DPROJECT_SOURCE_DIR="${PROJECT_SOURCE_DIR}")  # Needed to print file paths.

set(CMAKE_CXX_FLAGS_DEBUG
  "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wextra -Werror -Wno-sign-compare -Wnon-virtual-dtor -Wno-missing-field-initializers -Wold-style-cast")

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  CHECK_COMPILER_VERSION("4.9")  # TODO: Wpedantic with gcc 4.9 errors with default arg lambdas.
  set(CMAKE_CXX_FLAGS_DEBUG
    "${CMAKE_CXX_FLAGS_DEBUG} -Wredundant-decls -Wcast-align -Wlogical-op -Wvla -Wuseless-cast -Wunreachable-code")

  if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 5)
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wshadow -Wpedantic -Wmissing-declarations")
  endif()

elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  CHECK_COMPILER_VERSION("3.6")
  set(CMAKE_CXX_FLAGS_DEBUG
    "${CMAKE_CXX_FLAGS_DEBUG} -Wno-missing-braces -Wshadow -Wunused-exception-parameter")

elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
  CHECK_COMPILER_VERSION("6.1")

elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
  CHECK_COMPILER_VERSION("17.0.2")
  # TODO: CMAKE_CXX_STANDARD has no effect on icc.
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
  # TODO: Warning with overload of private override.
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -diag-disable=1125")
endif()

if(WITH_COVERAGE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")
endif()

if(WITH_PROFILE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
endif()

if(WIN32)
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wno-error")
endif()

find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
  message(STATUS "Using CCache for builds")
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)

  if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR
     "${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
    add_definitions("-Qunused-arguments")  # TODO: CCache bug with not splitting args.
  endif()
endif()

######################## End compiler configurations ####################

##################### Begin cmake configuration ###################

include(CTest)

# Setup build locations.
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${SCRAM_BINARY_DIR}/bin")
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${SCRAM_BINARY_DIR}/lib/scram")
endif()
if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${SCRAM_BINARY_DIR}/lib/scram")
endif()

# Use, i.e. don't skip the full RPATH for the build tree.
set(CMAKE_SKIP_BUILD_RPATH FALSE)

# When building,
# don't use the install RPATH already
# (but later on when installing).
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib/scram")
set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib/scram")

# Add the automatically determined parts of the RPATH,
# which point to directories outside the build tree
# to the install RPATH.
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# Tell CMake where the modules are.
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

######################## End cmake configuration ###################

######################## Begin find libraries ######################

set(MALLOC "System Malloc")
# Optional alternative Malloc for optimization.
if(NOT WITH_PROFILE)
  find_package(Tcmalloc)
  find_package(JeMalloc)
  if(WITH_TCMALLOC AND Tcmalloc_FOUND)
    list(APPEND LIBS ${Tcmalloc_LIBRARIES})
    set(MALLOC "TCMalloc")
  elseif(WITH_JEMALLOC AND JEMALLOC_FOUND)
    list(APPEND LIBS ${JEMALLOC_LIBRARIES})
    set(MALLOC "JEMalloc")
  endif()
endif()
message(STATUS "The memory allocator: ${MALLOC}")

# Find LibXML2 and dependencies.
find_package(LibXml2 REQUIRED)
list(APPEND LIBS ${LIBXML2_LIBRARIES})

# Include the boost header files and the program_options library.
# Please be sure to use Boost rather than BOOST.
if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  set(BOOST_MIN_VERSION "1.58.0")
  list(APPEND LIBS ${CMAKE_DL_LIBS})
else()
  set(BOOST_MIN_VERSION "1.61.0")
endif()

if(NOT WIN32)
  set(Boost_USE_MULTITHREADED OFF)
endif()

find_package(Boost ${BOOST_MIN_VERSION} REQUIRED COMPONENTS
  program_options filesystem system date_time random
  )
message(STATUS "Boost Include directory: ${Boost_INCLUDE_DIR}")
message(STATUS "Boost Library directories: ${Boost_LIBRARY_DIRS}")
list(APPEND LIBS ${Boost_LIBRARIES})

message(STATUS "Libraries: ${LIBS}")

########################## End of find libraries ########################

########################## Begin includes ###############################

# Include all the discovered system directories.
include_directories(SYSTEM "${Boost_INCLUDE_DIR}")
include_directories(SYSTEM "${LIBXML2_INCLUDE_DIR}")

include_directories("${CMAKE_SOURCE_DIR}")  # Include the core headers via "src".

add_subdirectory(src)
add_subdirectory(share)
add_subdirectory(input)

if(BUILD_GUI)
  add_subdirectory(gui)
endif()

if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

####################### End includes ####################################

###################### Begin uninstall target ###########################

configure_file(cmake/cmake_uninstall.cmake.in cmake_uninstall.cmake @ONLY)
add_custom_target(uninstall
  COMMAND "${CMAKE_COMMAND}" -P "\"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake\"")

###################### End uninstall target #############################

###################### Begin CPACK configurations ###########################

if(PACKAGE)
  if(WIN32)
    set(CPACK_GENERATOR "NSIS")
    # set(CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}\\\\gui\\\\images\\\\scram_logo.bmp")
    set(CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\scram-gui.exe")
    set(CPACK_NSIS_MODIFY_PATH ON)
    set(CPACK_NSIS_HELP_LINK "https://scram-pra.org")
    set(CPACK_NSIS_URL_INFO_ABOUT "https://scram-pra.org")
    set(CPACK_NSIS_CONTACT "scram-users@googlegroups.com")
    set(CPACK_PACKAGE_EXECUTABLES "scram-gui" "SCRAM")
    set(CPACK_CREATE_DESKTOP_LINKS "scram-gui")
    set(CPACK_COMPONENT_GUI_REQUIRED ON)
    # The following configuration assumes MinGW64 is setup specifically for this project.
    get_filename_component(MINGW_DLL_DIR "${CMAKE_CXX_COMPILER}" PATH)
    message(STATUS "MinGW bin location: ${MINGW_DLL_DIR}")
    include(ScramBundle)
    get_scram_prerequisites(SCRAM_PREREQUISITES
      "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/scram.exe" "${MINGW_DLL_DIR}")
    install(FILES
      ${SCRAM_PREREQUISITES}
      DESTINATION bin COMPONENT libraries
    )
    get_scram_prerequisites(SCRAM_GUI_PREREQUISITES
      "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/scram-gui.exe" "${MINGW_DLL_DIR}")
    install(FILES
      ${SCRAM_GUI_PREREQUISITES}
      DESTINATION bin COMPONENT libraries
    )
  endif()
endif()

set(CPACK_PACKAGE_VENDOR "Olzhas Rakhimov")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Probabilistic risk analysis tool")
set(CPACK_PACKAGE_VERSION_MAJOR "${PROJECT_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${PROJECT_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${PROJECT_VERSION_PATCH}")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/LICENSE")

set(CPACK_STRIP_FILES ON)

set(CPACK_COMPONENTS_ALL scram libraries gui examples)
set(CPACK_COMPONENT_SCRAM_REQUIRED ON)
set(CPACK_COMPONENT_LIBRARIES_REQUIRED ON)

include(CPack)

###################### End CPACK configurations #############################

=== gui/CMakeLists.txt ===
# Find Qt5 libraries.
if(APPLE)
  # Qt5 with Homebrew.
  list(APPEND CMAKE_PREFIX_PATH /usr/local/opt/qt5)
endif()
find_package(Qt5 "5.2.1" REQUIRED COMPONENTS
  Core Widgets Svg OpenGL PrintSupport Concurrent
  )
message(STATUS "Found Qt5")
message(STATUS "Qt5 Version: ${Qt5_VERSION}")

# Prevent implicit QString(const char*), string concat with "+", and other anti-patterns.
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII -DQT_NO_CAST_FROM_BYTEARRAY -DQT_NO_URL_CAST_FROM_STRING -DQT_USE_QSTRINGBUILDER")

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  # TODO: MOC generated code has some useless casts.
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wno-useless-cast")
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
  # TODO: Qt moc offsetof applied to non-POD types is nonstandard.
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -diag-disable=1875")
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  if(Qt5Widgets_VERSION_STRING VERSION_LESS 5.4)
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wno-inconsistent-missing-override")
  endif()
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

set(SCRAM_GUI_RES res.qrc)

if(NOT HAS_TANGO AND (WIN32 OR APPLE))
  set(TANGO_QRC qtango/icons/tango/tango.qrc)
  execute_process(
    COMMAND python generate_rcc.py icons/tango/index.theme
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qtango
    RESULT_VARIABLE qtango_return
    OUTPUT_VARIABLE qtango_out
    ERROR_VARIABLE qtango_out
    )
  if(qtango_return)
    message(FATAL_ERROR "Tango icon generation failed: ${qtango_out}")
  endif()
  list(APPEND SCRAM_GUI_RES "${TANGO_QRC}")
endif()

add_subdirectory(translations)

set(SCRAM_GUI_SRC
  language.cpp
  validator.cpp
  model.cpp
  modeltree.cpp
  reporttree.cpp
  elementcontainermodel.cpp
  importancetablemodel.cpp
  producttablemodel.cpp
  preferencesdialog.cpp
  settingsdialog.cpp
  eventdialog.cpp
  printable.cpp
  zoomableview.cpp
  diagram.cpp
  mainwindow.cpp
  )
add_library(scram-gui STATIC ${SCRAM_GUI_SRC})
target_link_libraries(scram-gui
  ${LIBS} scram
  Qt5::Core Qt5::Gui Qt5::Widgets Qt5::Svg Qt5::OpenGL Qt5::PrintSupport Qt5::Concurrent)

add_executable(scram-gui-bin WIN32 main.cpp scram.rc ${SCRAM_GUI_RES})
set_target_properties(scram-gui-bin PROPERTIES OUTPUT_NAME scram-gui)
target_link_libraries(scram-gui-bin scram-gui scram ${Boost_LIBRARIES})
install(
  TARGETS scram-gui-bin
  RUNTIME DESTINATION bin
  COMPONENT gui
  )

if(UNIX AND NOT APPLE)
  foreach (size IN ITEMS 32 128)
    install(
      FILES       images/scram_solid${size}x${size}.png
      DESTINATION share/icons/hicolor/${size}x${size}/apps
      COMPONENT gui
      RENAME      scram.png)
  endforeach ()
  install(
    FILES       images/scram_solid.svg
    DESTINATION share/icons/hicolor/scalable/apps
    COMPONENT gui
    RENAME      scram.svg)

  # Install a desktop file
  # so that SCRAM appears in the application start menu with an icon.
  install(FILES scram-gui.desktop
    DESTINATION share/applications
    COMPONENT gui)
endif()

if(PACKAGE)
  if(WIN32)
    # Helper functions to bundle the dependencies.
    macro(install_qt5_plugin _qt_plugin_name _qt_plugins_var)
      get_target_property(_qt_plugin_path "${_qt_plugin_name}" LOCATION)
      if(EXISTS "${_qt_plugin_path}")
        get_filename_component(_qt_plugin_file "${_qt_plugin_path}" NAME)
        get_filename_component(_qt_plugin_type "${_qt_plugin_path}" PATH)
        get_filename_component(_qt_plugin_type "${_qt_plugin_type}" NAME)
        if(APPLE)
          set(_qt_plugin_dir "PlugIns")
        elseif(WIN32)
          set(_qt_plugin_dir "plugins")
        endif()
        set(_qt_plugin_dest "${_qt_plugin_dir}/${_qt_plugin_type}")
        install(FILES "${_qt_plugin_path}"
          DESTINATION "${_qt_plugin_dest}"
          COMPONENT gui)
        set(${_qt_plugins_var}
          "${${_qt_plugins_var}};\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${_qt_plugin_dest}/${_qt_plugin_file}")
      else()
        message(FATAL_ERROR "QT plugin ${_qt_plugin_name} not found")
      endif()
    endmacro()
    install_qt5_plugin("Qt5::QWindowsIntegrationPlugin" QT_PLUGINS)

    execute_process(COMMAND qmake -query QT_INSTALL_TRANSLATIONS
      OUTPUT_VARIABLE QT_TRANSLATIONS_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
    install(
      DIRECTORY "${QT_TRANSLATIONS_DIR}/"
      DESTINATION translations
      COMPONENT gui
      FILES_MATCHING PATTERN "qtbase_*" PATTERN "qt_*" PATTERN "qt_help_*" EXCLUDE
      )

    file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/qt.conf"
      "[Paths]\nPlugins = ../${_qt_plugin_dir}\nTranslations = ../translations\n")
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/qt.conf"
      DESTINATION bin
      COMPONENT gui)
  endif()
endif()

if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

=== src/CMakeLists.txt ===
################### File Configurations #######################
execute_process(COMMAND git describe --tags OUTPUT_VARIABLE core_version
  OUTPUT_STRIP_TRAILING_WHITESPACE)
configure_file(version.cc.in version.cc @ONLY)
configure_file(env.cc.in env.cc @ONLY)
################### End File Configurations ####################

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(SCRAM_CORE_SRC
  ${CMAKE_CURRENT_BINARY_DIR}/env.cc
  ${CMAKE_CURRENT_BINARY_DIR}/version.cc
  logger.cc
  random.cc
  settings.cc
  xml.cc
  config.cc
  element.cc
  expression.cc
  parameter.cc
  expression/conditional.cc
  expression/constant.cc
  expression/numerical.cc
  expression/exponential.cc
  expression/random_deviate.cc
  expression/test_event.cc
  expression/extern.cc
  event.cc
  substitution.cc
  ccf_group.cc
  fault_tree.cc
  event_tree.cc
  alignment.cc
  model.cc
  pdag.cc
  preprocessor.cc
  mocus.cc
  bdd.cc
  zbdd.cc
  analysis.cc
  fault_tree_analysis.cc
  probability_analysis.cc
  importance_analysis.cc
  uncertainty_analysis.cc
  event_tree_analysis.cc
  reporter.cc
  serialization.cc
  initializer.cc
  risk_analysis.cc
  )
add_library(scram SHARED ${SCRAM_CORE_SRC})
target_link_libraries(scram ${LIBS})

install(
  TARGETS scram
  LIBRARY DESTINATION lib/scram
  ARCHIVE DESTINATION lib/scram/static
  RUNTIME DESTINATION bin
  COMPONENT scram
  )

add_executable(scram-cli scram.cc)
set_target_properties(scram-cli PROPERTIES OUTPUT_NAME scram)
target_link_libraries(scram-cli scram ${Boost_LIBRARIES})

install(
  TARGETS scram-cli
  RUNTIME DESTINATION bin
  COMPONENT scram
  )

=== tests/CMakeLists.txt ===
# Exclude Debug warnings from the framework.
set(CURRENT_DEBUG_FLAGS "${CMAKE_CXX_FLAGS_DEBUG}")
set(CMAKE_CXX_FLAGS_DEBUG "-g")

set(GTEST_DIR googletest/googletest)

add_subdirectory("${GTEST_DIR}" EXCLUDE_FROM_ALL)

set(CMAKE_CXX_FLAGS_DEBUG "${CURRENT_DEBUG_FLAGS}")  # Restore the original flags.

include_directories(SYSTEM "${GTEST_DIR}/include")

# Include the project headers.
include_directories("${CMAKE_SOURCE_DIR}/src")
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(SCRAM_CORE_TEST_SOURCE
  linear_map_tests.cc
  xml_stream_tests.cc
  settings_tests.cc
  config_tests.cc
  element_tests.cc
  event_tests.cc
  expression_tests.cc
  extern_function_tests.cc
  ccf_group_tests.cc
  fault_tree_tests.cc
  alignment_tests.cc
  pdag_tests.cc
  initializer_tests.cc
  risk_analysis_tests.cc
  serialization_tests.cc
  bench_core_tests.cc
  bench_two_train_tests.cc
  bench_lift_tests.cc
  bench_ne574_tests.cc
  bench_theatre_tests.cc
  bench_three_motor_tests.cc
  bench_200_event_tests.cc
  bench_small_tree_tests.cc
  bench_bscu_tests.cc
  bench_chinese_tree_tests.cc
  bench_baobab1_tests.cc
  bench_baobab2_tests.cc
  bench_CEA9601_tests.cc
  bench_hipps_tests.cc
  bench_attack.cc
  bench_gas_leak.cc
  performance_tests.cc
  )

# Make tests switch and run in install directory.
configure_file(scram_unit_test_driver.cc.in scram_unit_test_driver.cc @ONLY)

add_executable(scram_tests ${CMAKE_CURRENT_BINARY_DIR}/scram_unit_test_driver.cc ${SCRAM_CORE_TEST_SOURCE})

target_link_libraries(scram_tests ${LIBS} scram gtest)

install(
  TARGETS scram_tests
  RUNTIME DESTINATION bin
  COMPONENT testing
  )

# Create dummy library to test dynamic loading and extern function.
add_library(scram_dummy_extern SHARED scram_dummy_extern.cc)
if(WIN32)
  set(CMAKE_SHARED_LIBRARY_PREFIX "")
install(
  TARGETS scram_dummy_extern
  LIBRARY DESTINATION "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}"
  ARCHIVE DESTINATION "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/static"
  RUNTIME DESTINATION "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}"
  COMPONENT testing
  )
endif()

=== gui/tests/CMakeLists.txt ===
find_package(Qt5Test REQUIRED)

# There are no tr() strings in test, so no need to be strict with string construction.
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -UQT_NO_CAST_FROM_ASCII")

macro(TEST NAME FILE)
  add_executable(scramgui_${NAME} ${FILE})
  target_link_libraries(scramgui_${NAME} scram-gui Qt5::Test)
  install(
    TARGETS scramgui_${NAME}
    RUNTIME DESTINATION bin
    COMPONENT testing
    )
  add_test(${NAME} scramgui_${NAME})
endmacro()

set(SCRAM_GUI_TEST_SRC
  testvalidator.cpp
  testlanguage.cpp
  testmodel.cpp
  )

foreach(testfile ${SCRAM_GUI_TEST_SRC})
  get_filename_component(testname "${testfile}" NAME_WE)
  TEST("${testname}" "${testfile}")
endforeach()

=== debian/changelog ===
scram (0.16.1-1) unstable; urgency=medium

  * New upstream release
  * Bump CMake required version to 3.5
  * Bump the standards version to 4.1.3
  * Remove irrelevant '-DBUILD_SHARED_LIBS' CMake build option
  * Remove 'BUILD_TESTS=OFF' build option (off by default)
  * Rename libscramcore to libscram (private library named by upstream)
  * Update manpages

 -- Olzhas Rakhimov <ol.rakhimov@gmail.com>  Thu, 04 Jan 2018 02:55:10 -0800

=== debian/control ===
Source: scram
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Olzhas Rakhimov <ol.rakhimov@gmail.com>
Build-Depends: debhelper (>= 10),
               cmake (>= 3.5),
               libxml2-dev (>= 2.9.1),
               libboost-all-dev (>= 1.58.0),
               libgoogle-perftools-dev,
               qtbase5-dev (>= 5.2.1),
               qtbase5-dev-tools,
               qttools5-dev,
               qttools5-dev-tools,
               libqt5svg5-dev,
               libqt5opengl5-dev
Standards-Version: 4.1.3
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/scram.git
Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/scram.git
Homepage: https://scram-pra.org

Package: scram
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Probabilistic Risk Analysis Tool
 A command line probabilistic risk analysis tool
 capable of performing event tree analysis,
 static fault tree analysis,
 analysis with common cause failure models,
 probability calculations with importance analysis,
 and uncertainty analysis with Monte Carlo simulations.

Package: scram-gui
Architecture: any
Depends: scram, ${shlibs:Depends}, ${misc:Depends}
Description: SCRAM GUI front-end
 The complementary SCRAM GUI front-end
 for visualization and manipulation
 of risk analysis models and reports.

## scram 0.16.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,10 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.8)
 
 # In-source build prevention.
 set(CMAKE_DISABLE_SOURCE_CHANGES ON)
 set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)
 
-project(SCRAM VERSION 0.16.1 LANGUAGES CXX)
+project(SCRAM VERSION 0.16.2 LANGUAGES CXX)
 
 ####################### Begin Options ###################
 
@@ -27,8 +27,8 @@
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)  # Needed for Clang Tooling.
 
-# Default to C++14.
-set(CMAKE_CXX_STANDARD 14)
+# Default to C++17.
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
 
@@ -40,32 +40,37 @@
 
 add_definitions(-DPROJECT_SOURCE_DIR="${PROJECT_SOURCE_DIR}")  # Needed to print file paths.
 
-set(CMAKE_CXX_FLAGS_DEBUG
-  "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wextra -Werror -Wno-sign-compare -Wnon-virtual-dtor -Wno-missing-field-initializers -Wold-style-cast")
+# Strict debug flags for SCRAM targets (opt-in, must subscribe to quality checks explicitly).
+# NOTE: This is a list unlike CMAKE_CXX_FLAGS.
+set(SCRAM_CXX_FLAGS_DEBUG
+  -Wall -Wextra -Werror -Wno-sign-compare -Wnon-virtual-dtor
+  -Wno-missing-field-initializers -Wold-style-cast
+  )
 
 if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
-  CHECK_COMPILER_VERSION("4.9")  # TODO: Wpedantic with gcc 4.9 errors with default arg lambdas.
-  set(CMAKE_CXX_FLAGS_DEBUG
-    "${CMAKE_CXX_FLAGS_DEBUG} -Wredundant-decls -Wcast-align -Wlogical-op -Wvla -Wuseless-cast -Wunreachable-code")
-
-  if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 5)
-    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wshadow -Wpedantic -Wmissing-declarations")
-  endif()
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-new-ttp-matching")  # TODO: Boost ICL failure.
+  CHECK_COMPILER_VERSION("7.1")
+  list(APPEND SCRAM_CXX_FLAGS_DEBUG
+    -Wredundant-decls -Wcast-align -Wlogical-op -Wvla -Wuseless-cast -Wunreachable-code
+    -Wshadow -Wpedantic -Wmissing-declarations
+    -Wimplicit-fallthrough=0  # TODO: Consider explicit fallthrough.
+    )
 
 elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
-  CHECK_COMPILER_VERSION("3.6")
-  set(CMAKE_CXX_FLAGS_DEBUG
-    "${CMAKE_CXX_FLAGS_DEBUG} -Wno-missing-braces -Wshadow -Wunused-exception-parameter")
+  CHECK_COMPILER_VERSION("5.0")
+  list(APPEND SCRAM_CXX_FLAGS_DEBUG -Wno-missing-braces -Wshadow -Wunused-exception-parameter)
 
 elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
-  CHECK_COMPILER_VERSION("6.1")
+  CHECK_COMPILER_VERSION("9.0")
 
 elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
-  CHECK_COMPILER_VERSION("17.0.2")
-  # TODO: CMAKE_CXX_STANDARD has no effect on icc.
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
+  CHECK_COMPILER_VERSION("18.0.1")
   # TODO: Warning with overload of private override.
-  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -diag-disable=1125")
+  list(APPEND SCRAM_CXX_FLAGS_DEBUG -diag-disable=1125)
+endif()
+
+if(WIN32)
+  list(APPEND SCRAM_CXX_FLAGS_DEBUG -Wno-error)
 endif()
 
 if(WITH_COVERAGE)
@@ -74,10 +79,6 @@
 
 if(WITH_PROFILE)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
-endif()
-
-if(WIN32)
-  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wno-error")
 endif()
 
 find_program(CCACHE_FOUND ccache)
@@ -85,11 +86,6 @@
   message(STATUS "Using CCache for builds")
   set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
   set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
-
-  if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR
-     "${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
-    add_definitions("-Qunused-arguments")  # TODO: CCache bug with not splitting args.
-  endif()
 endif()
 
 ######################## End compiler configurations ####################
@@ -153,23 +149,20 @@
 
 # Include the boost header files and the program_options library.
 # Please be sure to use Boost rather than BOOST.
-if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
-  set(BOOST_MIN_VERSION "1.58.0")
-  list(APPEND LIBS ${CMAKE_DL_LIBS})
-else()
-  set(BOOST_MIN_VERSION "1.61.0")
-endif()
+set(BOOST_MIN_VERSION "1.61.0")
 
 if(NOT WIN32)
   set(Boost_USE_MULTITHREADED OFF)
 endif()
 
 find_package(Boost ${BOOST_MIN_VERSION} REQUIRED COMPONENTS
-  program_options filesystem system date_time random
+  program_options filesystem system random
   )
 message(STATUS "Boost Include directory: ${Boost_INCLUDE_DIR}")
 message(STATUS "Boost Library directories: ${Boost_LIBRARY_DIRS}")
 list(APPEND LIBS ${Boost_LIBRARIES})
+
+list(APPEND LIBS ${CMAKE_DL_LIBS})
 
 message(STATUS "Libraries: ${LIBS}")

=== gui/CMakeLists.txt ===
--- 
+++ 
@@ -3,26 +3,11 @@
   # Qt5 with Homebrew.
   list(APPEND CMAKE_PREFIX_PATH /usr/local/opt/qt5)
 endif()
-find_package(Qt5 "5.2.1" REQUIRED COMPONENTS
+find_package(Qt5 "5.9.1" REQUIRED COMPONENTS
   Core Widgets Svg OpenGL PrintSupport Concurrent
   )
 message(STATUS "Found Qt5")
 message(STATUS "Qt5 Version: ${Qt5_VERSION}")
-
-# Prevent implicit QString(const char*), string concat with "+", and other anti-patterns.
-set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII -DQT_NO_CAST_FROM_BYTEARRAY -DQT_NO_URL_CAST_FROM_STRING -DQT_USE_QSTRINGBUILDER")
-
-if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
-  # TODO: MOC generated code has some useless casts.
-  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wno-useless-cast")
-elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
-  # TODO: Qt moc offsetof applied to non-POD types is nonstandard.
-  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -diag-disable=1875")
-elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
-  if(Qt5Widgets_VERSION_STRING VERSION_LESS 5.4)
-    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wno-inconsistent-missing-override")
-  endif()
-endif()
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
@@ -70,6 +55,11 @@
 target_link_libraries(scram-gui
   ${LIBS} scram
   Qt5::Core Qt5::Gui Qt5::Widgets Qt5::Svg Qt5::OpenGL Qt5::PrintSupport Qt5::Concurrent)
+target_compile_options(scram-gui PUBLIC $<$<CONFIG:DEBUG>:${SCRAM_CXX_FLAGS_DEBUG} -Wno-useless-cast>) # TODO: MOC failure.
+# Prevent implicit QString(const char*), string concat with "+", and other anti-patterns.
+target_compile_definitions(scram-gui PRIVATE
+  $<$<CONFIG:DEBUG>:QT_NO_CAST_FROM_ASCII QT_NO_CAST_TO_ASCII QT_NO_CAST_FROM_BYTEARRAY QT_NO_URL_CAST_FROM_STRING QT_USE_QSTRINGBUILDER>
+  )
 
 add_executable(scram-gui-bin WIN32 main.cpp scram.rc ${SCRAM_GUI_RES})
 set_target_properties(scram-gui-bin PROPERTIES OUTPUT_NAME scram-gui)
@@ -81,24 +71,26 @@
   )
 
 if(UNIX AND NOT APPLE)
-  foreach (size IN ITEMS 32 128)
+  foreach(size IN ITEMS 32 128)
     install(
       FILES       images/scram_solid${size}x${size}.png
       DESTINATION share/icons/hicolor/${size}x${size}/apps
-      COMPONENT gui
+      COMPONENT   gui
       RENAME      scram.png)
-  endforeach ()
+  endforeach()
+
   install(
     FILES       images/scram_solid.svg
     DESTINATION share/icons/hicolor/scalable/apps
-    COMPONENT gui
+    COMPONENT   gui
     RENAME      scram.svg)
 
   # Install a desktop file
   # so that SCRAM appears in the application start menu with an icon.
-  install(FILES scram-gui.desktop
+  install(
+    FILES       scram-gui.desktop
     DESTINATION share/applications
-    COMPONENT gui)
+    COMPONENT   gui)
 endif()
 
 if(PACKAGE)
@@ -116,7 +108,8 @@
           set(_qt_plugin_dir "plugins")
         endif()
         set(_qt_plugin_dest "${_qt_plugin_dir}/${_qt_plugin_type}")
-        install(FILES "${_qt_plugin_path}"
+        install(
+          FILES "${_qt_plugin_path}"
           DESTINATION "${_qt_plugin_dest}"
           COMPONENT gui)
         set(${_qt_plugins_var}
@@ -138,7 +131,8 @@
 
     file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/qt.conf"
       "[Paths]\nPlugins = ../${_qt_plugin_dir}\nTranslations = ../translations\n")
-    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/qt.conf"
+    install(
+      FILES "${CMAKE_CURRENT_BINARY_DIR}/qt.conf"
       DESTINATION bin
       COMPONENT gui)
   endif()

=== input/CMakeLists.txt ===
# Copy example files into the shared directory.
install(DIRECTORY
  Baobab
  Chinese
  CEA9601
  ne574
  SmallTree
  BSCU
  Theatre
  TwoTrain
  ThreeMotor
  Lift
  HIPPS
  EventTrees
  DESTINATION share/scram/input
  COMPONENT examples
  FILES_MATCHING PATTERN "*.xml"
  PATTERN "RiskMan*" EXCLUDE
  )

=== share/CMakeLists.txt ===
install(FILES
  config.rng
  input.rng
  report.rng
  DESTINATION share/scram
  COMPONENT scram
  )

if(BUILD_GUI)
  install(FILES
    gui.rng
    DESTINATION share/scram
    COMPONENT gui
  )
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -2,16 +2,14 @@
 execute_process(COMMAND git describe --tags OUTPUT_VARIABLE core_version
   OUTPUT_STRIP_TRAILING_WHITESPACE)
 configure_file(version.cc.in version.cc @ONLY)
-configure_file(env.cc.in env.cc @ONLY)
 ################### End File Configurations ####################
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
 set(SCRAM_CORE_SRC
-  ${CMAKE_CURRENT_BINARY_DIR}/env.cc
+  env.cc
   ${CMAKE_CURRENT_BINARY_DIR}/version.cc
   logger.cc
-  random.cc
   settings.cc
   xml.cc
   config.cc
@@ -50,6 +48,7 @@
   )
 add_library(scram SHARED ${SCRAM_CORE_SRC})
 target_link_libraries(scram ${LIBS})
+target_compile_options(scram PRIVATE $<$<CONFIG:DEBUG>:${SCRAM_CXX_FLAGS_DEBUG}>)
 
 install(
   TARGETS scram
@@ -62,6 +61,7 @@
 add_executable(scram-cli scram.cc)
 set_target_properties(scram-cli PROPERTIES OUTPUT_NAME scram)
 target_link_libraries(scram-cli scram ${Boost_LIBRARIES})
+target_compile_options(scram-cli PRIVATE $<$<CONFIG:DEBUG>:${SCRAM_CXX_FLAGS_DEBUG}>)
 
 install(
   TARGETS scram-cli

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,4 @@
-# Exclude Debug warnings from the framework.
-set(CURRENT_DEBUG_FLAGS "${CMAKE_CXX_FLAGS_DEBUG}")
-set(CMAKE_CXX_FLAGS_DEBUG "-g")
-
-set(GTEST_DIR googletest/googletest)
-
-add_subdirectory("${GTEST_DIR}" EXCLUDE_FROM_ALL)
-
-set(CMAKE_CXX_FLAGS_DEBUG "${CURRENT_DEBUG_FLAGS}")  # Restore the original flags.
-
-include_directories(SYSTEM "${GTEST_DIR}/include")
+include_directories(SYSTEM "catch2/single_include")
 
 # Include the project headers.
 include_directories("${CMAKE_SOURCE_DIR}/src")
@@ -28,8 +18,8 @@
   alignment_tests.cc
   pdag_tests.cc
   initializer_tests.cc
+  serialization_tests.cc
   risk_analysis_tests.cc
-  serialization_tests.cc
   bench_core_tests.cc
   bench_two_train_tests.cc
   bench_lift_tests.cc
@@ -53,8 +43,8 @@
 configure_file(scram_unit_test_driver.cc.in scram_unit_test_driver.cc @ONLY)
 
 add_executable(scram_tests ${CMAKE_CURRENT_BINARY_DIR}/scram_unit_test_driver.cc ${SCRAM_CORE_TEST_SOURCE})
-
-target_link_libraries(scram_tests ${LIBS} scram gtest)
+target_link_libraries(scram_tests ${LIBS} scram)
+target_compile_options(scram_tests PRIVATE $<$<CONFIG:DEBUG>:${SCRAM_CXX_FLAGS_DEBUG}>)
 
 install(
   TARGETS scram_tests
@@ -64,6 +54,7 @@
 
 # Create dummy library to test dynamic loading and extern function.
 add_library(scram_dummy_extern SHARED scram_dummy_extern.cc)
+target_compile_options(scram_dummy_extern PRIVATE $<$<CONFIG:DEBUG>:${SCRAM_CXX_FLAGS_DEBUG}>)
 if(WIN32)
   set(CMAKE_SHARED_LIBRARY_PREFIX "")
 install(

=== gui/tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,4 @@
 find_package(Qt5Test REQUIRED)
-
-# There are no tr() strings in test, so no need to be strict with string construction.
-set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -UQT_NO_CAST_FROM_ASCII")
 
 macro(TEST NAME FILE)
   add_executable(scramgui_${NAME} ${FILE})

=== gui/translations/CMakeLists.txt ===
find_package(Qt5LinguistTools REQUIRED)
message(STATUS "Found Qt5 Linguist")

# The translation is setup with Crowdin.
# The English locale is a reference for all the other locales.
# Use 'lupdate' directly to update the English locale only.
# The other locales will be updated by Crowdin automatically.
#
# The following commented code does what lupdate does;
# however, this doesn't play well with CMake out-of-source builds.
#
# set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM 1)  # prevent 'make clean'
# set(SCRAM_GUI_TS_ORIGIN scramgui_en.ts)
# qt5_create_translation(TRANSLATION_MESSAGES .. ${SCRAM_GUI_TS_ORIGIN})
# add_custom_target(translations_update DEPENDS ${TRANSLATION_MESSAGES})

# The En locale is default reference,
# so TS only includes non-En locales.
# Ideally, 90% minimum translation coverage is desired for inclusion.
qt5_add_translation(SCRAM_GUI_QM
  scramgui_ru_RU.ts
  scramgui_de_DE.ts
  scramgui_es_ES.ts
  scramgui_tr_TR.ts
  scramgui_nl_NL.ts
  scramgui_id_ID.ts
  scramgui_pl_PL.ts
  scramgui_it_IT.ts
  )
message(STATUS "GUI translations: ${SCRAM_GUI_QM}")
add_custom_target(translations ALL DEPENDS ${SCRAM_GUI_QM})
install(FILES ${SCRAM_GUI_QM} DESTINATION share/scram/translations COMPONENT gui)

=== debian/changelog ===
scram (0.16.2-4) unstable; urgency=medium

  * Team upload
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on cmake, g++, libboost-all-dev
      and qtbase5-dev
  * Build with libxml 2.9 (Closes: #1073328)

 -- Bastian Germann <bage@debian.org>  Mon, 25 Aug 2025 17:01:13 +0200

scram (0.16.2-3) unstable; urgency=medium

  * Team Upload.
  * Fix FTBFS with DEB_BUILD_OPTIONS=reproducible=+fixfilepath
    - Thank you, Vagrant Cascadian (Closes: #972297)
  * Fix HOME to Enable building on sbuild
  * Bump debhelper-compat version to 13
  * Add "Rules-Requires-Root:no"

 -- Nilesh Patra <npatra974@gmail.com>  Fri, 15 Jan 2021 22:07:59 +0530

scram (0.16.2-2) unstable; urgency=medium

  * Team upload.
  * [bb08829] Add .gitlab-ci.yml
  * [bdd4875] Fix compilation against boost_1.74. (Closes: #975660)
  * [9f0eef0] Use secure copyright file specification URI.
  * [c9e5bdf] Bump debhelper from old 10 to 12. + debian/rules:
              Rely on default use of dh_missing rather thanusing
              dh_install --list-missing.
  * [3c115ed] Set debhelper-compat version in Build-Depends.
  * [5832136] Set upstream metadata fields:
              Bug-Database, Bug-Submit, Repository, Repository-Browse.
  * [41fc902] Set Standards-Version 4.5.1. No changes
  * [15dc93c] Allow blhc to fail

 -- Anton Gladky <gladk@debian.org>  Wed, 16 Dec 2020 22:34:36 +0100

scram (0.16.2-1) unstable; urgency=medium

  * New upstream release
  * Require g++ 7.1 or later (for C++17)
  * Bump CMake required version to 3.8
  * Bump Boost required version to 1.61
  * Bump Qt required version to 5.9.1
  * Update copyright years w/ 2018
  * Update man pages
  * Add copyright to boost.scope_guard source
  * Update VCS control fields to point to Salsa

 -- Olzhas Rakhimov <ol.rakhimov@gmail.com>  Fri, 12 Jan 2018 04:28:58 -0800

=== debian/control ===
Source: scram
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Olzhas Rakhimov <ol.rakhimov@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               libxml2.9-dev,
               libboost-all-dev,
               libgoogle-perftools-dev,
               qtbase5-dev,
               qtbase5-dev-tools,
               qttools5-dev,
               qttools5-dev-tools,
               libqt5svg5-dev,
               libqt5opengl5-dev
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/science-team/scram
Vcs-Git: https://salsa.debian.org/science-team/scram.git
Homepage: https://scram-pra.org
Rules-Requires-Root: no

Package: scram
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Probabilistic Risk Analysis Tool
 A command line probabilistic risk analysis tool
 capable of performing event tree analysis,
 static fault tree analysis,
 analysis with common cause failure models,
 probability calculations with importance analysis,
 and uncertainty analysis with Monte Carlo simulations.

Package: scram-gui
Architecture: any
Depends: scram,
         ${shlibs:Depends},
         ${misc:Depends}
Description: SCRAM GUI front-end
 The complementary SCRAM GUI front-end
 for visualization and manipulation
 of risk analysis models and reports.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Disable fixfilepath as it triggers a build failure.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=-fixfilepath
export DEB_LDFLAGS_MAINT_PREPEND = -Wl,-z,defs -Wl,--as-needed
export QT_SELECT=qt5
export HOME := $(CURDIR)/debian/HOME

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release

%:
	dh $@ --buildsystem=cmake

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/scram-$1\.tar\.gz/ \
  https://github.com/rakhimov/scram/releases .*/v?(\d\S+)\.tar\.gz
